> ## Documentation Index
> Fetch the complete documentation index at: https://docs.memobase.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Flush Buffer

> Flush unprocessed blobs into Memory

Flush the memory buffer for a specific user and buffer type. This endpoint ensures all pending memory operations are processed and committed to long-term storage.


## OpenAPI

````yaml post /api/v1/users/buffer/{user_id}/{buffer_type}
openapi: 3.1.0
info:
  title: Memobase API
  summary: APIs for Memobase, a user memory system for LLM Apps
  version: 0.0.40
servers:
  - url: https://api.memobase.dev
  - url: https://api.memobase.cn
security:
  - BearerAuth: []
paths:
  /api/v1/users/buffer/{user_id}/{buffer_type}:
    post:
      tags:
        - buffer
      summary: Flush Buffer
      description: Flush unprocessed blobs into Memory
      operationId: flush_buffer_api_v1_users_buffer__user_id___buffer_type__post
      parameters:
        - name: user_id
          in: path
          required: true
          schema:
            anyOf:
              - type: string
                format: uuid4
              - type: string
                format: uuid5
            description: The ID of the user
            title: User Id
          description: The ID of the user
        - name: buffer_type
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/BlobType'
            description: The type of buffer to flush
          description: The type of buffer to flush
        - name: wait_process
          in: query
          required: false
          schema:
            type: boolean
            description: Whether to wait for the buffer to be processed
            default: false
            title: Wait Process
          description: Whether to wait for the buffer to be processed
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ChatModalAPIResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-code-samples:
        - lang: python
          source: >+
            # To use the Python SDK, install the package:

            # pip install memobase


            from memobase import MemoBaseClient


            client = MemoBaseClient(project_url='PROJECT_URL',
            api_key='PROJECT_TOKEN')


            u = client.get_user(uid)

            u.flush()

            u.flush(sync=True) # wait for the buffer to be processed

          label: Python
        - lang: javascript
          source: >+
            // To use the JavaScript SDK, install the package:

            // npm install @memobase/memobase


            import { MemoBaseClient, BlobType } from '@memobase/memobase';


            const client = new MemoBaseClient(process.env.MEMOBASE_PROJECT_URL,
            process.env.MEMOBASE_API_KEY);

            const user = await client.getUser(userId);


            await user.flush(BlobType.Enum.chat);

          label: JavaScript
        - lang: go
          source: >+
            // To use the Go SDK, install the package:

            // go get
            github.com/memodb-io/memobase/src/client/memobase-go@latest


            import (
                "fmt"
                "log"

                "github.com/memodb-io/memobase/src/client/memobase-go/blob"
                "github.com/memodb-io/memobase/src/client/memobase-go/core"
            )


            func main() {
                projectURL := "YOUR_PROJECT_URL"
                apiKey := "YOUR_API_KEY"
                // Initialize the client
                client, err := core.NewMemoBaseClient(
                    projectURL,
                    apiKey,
                )
                if err != nil {
                    log.Fatalf("Failed to create client: %v", err)
                }

                // Get a user
                userID := "EXISTING_USER_ID" // Replace with an actual user ID
                user, err := client.GetUser(userID, false)
                if err != nil {
                    log.Fatalf("Failed to get user: %v", err)
                }

                // Flush the buffer
                err = user.Flush(blob.ChatType, false)
                if err != nil {
                    log.Fatalf("Failed to flush buffer: %v", err)
                }
                fmt.Println("Successfully flushed buffer")
            }

          label: Go
components:
  schemas:
    BlobType:
      type: string
      enum:
        - chat
        - summary
        - doc
        - image
        - code
        - transcript
      title: BlobType
    ChatModalAPIResponse:
      properties:
        data:
          anyOf:
            - items:
                $ref: '#/components/schemas/ChatModalResponse'
              type: array
            - type: 'null'
          title: Data
          description: Response containing chat modal data
        errno:
          $ref: '#/components/schemas/CODE'
          description: Error code, 0 means success
          default: 0
        errmsg:
          type: string
          title: Errmsg
          description: Error message, empty when success
          default: ''
      type: object
      title: ChatModalAPIResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ChatModalResponse:
      properties:
        event_id:
          anyOf:
            - type: string
              format: uuid4
            - type: string
              format: uuid5
            - type: 'null'
          title: Event Id
          description: The event's unique identifier
        add_profiles:
          anyOf:
            - items:
                anyOf:
                  - type: string
                    format: uuid4
                  - type: string
                    format: uuid5
              type: array
            - type: 'null'
          title: Add Profiles
          description: List of added profiles' ids
        update_profiles:
          anyOf:
            - items:
                anyOf:
                  - type: string
                    format: uuid4
                  - type: string
                    format: uuid5
              type: array
            - type: 'null'
          title: Update Profiles
          description: List of updated profiles' ids
        delete_profiles:
          anyOf:
            - items:
                anyOf:
                  - type: string
                    format: uuid4
                  - type: string
                    format: uuid5
              type: array
            - type: 'null'
          title: Delete Profiles
          description: List of deleted profiles' ids
      type: object
      required:
        - event_id
        - add_profiles
        - update_profiles
        - delete_profiles
      title: ChatModalResponse
    CODE:
      type: integer
      enum:
        - 0
        - 400
        - 401
        - 403
        - 404
        - 405
        - 409
        - 422
        - 500
        - 501
        - 502
        - 503
        - 504
        - 520
      title: CODE
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````